package com.dgtly.common.utils;

import com.dgtly.common.utils.http.HttpUtils;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

/**
 * @author koucx
 * @version 1.0
 * @descption: TODO
 * @company 神州数码通用软件（洛阳）有限公司
 * @copyright (c) 2019 LuoYang DGT Co'Ltd Inc. All rights reserved.
 * @date 2020-03-24
 * @since JDK1.8
 */
public class TranslateUtil {

    private static final Logger log = LoggerFactory.getLogger(TranslateUtil.class);

    private static final String TRANSLATE_URL_OLD = "http://fanyi.youdao.com/translate";
    private static final String TRANSLATE_URL = "http://fanyi.youdao.com/openapi.do";

    /**
     * @Description: 调用有道翻译接口中文翻译成英文
     * @Param: [msg]
     * @Return: java.lang.String
     * @Author: koucx
     * @Date: 2020-03-24
    **/
    public static String getEnTranslateInfo(String msg){
        String params = "doctype=json&type=ZH_CN2EN&i="+msg;
        String enInfo = HttpUtils.sendGet(TRANSLATE_URL_OLD, params);
        /**
         * {
         *     "type": "ZH_CN2EN",
         *     "errorCode": 0,
         *     "elapsedTime": 1,
         *     "translateResult": [
         *         [
         *             {
         *                 "src": "计算",//需要翻译的中文
         *                 "tgt": "To calculate"//翻译后的中文
         *             }
         *         ]
         *     ]
         * }
         *
         * 根据以上json串获取相应英文翻译
         *
         */
            JSONObject object = JSONObject.fromObject(enInfo);
            if(object!=null){
                JSONArray array = object.getJSONArray("translateResult");
                if(array!=null && array.size()>0){
                    for (Object obj:array) {
                        JSONArray arr = JSONArray.fromObject(obj);
                        for (Object o:arr) {
                            JSONObject json = JSONObject.fromObject(o);
                            if(json!=null && json.containsKey("tgt")){
                                String tgt = json.getString("tgt");
                                System.out.println("'"+json.getString("src")+"'翻译后'"+tgt+"'");
                                return tgt;
                            }
                        }
                    }
                }
            }
        return "";
    }

    /**
     * @Description: 调用有道翻译接口中文翻译成英文
     * @Param: [msg]
     * @Verision:2.0
     * @Return: java.lang.String
     * @Author: koucx
     * @Date: 2020-03-24
     **/
    public static String getEnTranslateInfoOld(String msg){

        try{
            if(StringUtils.isNotEmpty(msg)){
                String params = "keyfrom=pdblog&key=993123434&type=data&doctype=json&version=1.1&q="+ URLEncoder.encode(msg,"utf-8");
                String enInfo = HttpUtils.sendGet(TRANSLATE_URL, params);
                JSONObject jsonObject = JSONObject.fromObject(enInfo);
                if(jsonObject!=null){
                    Object obj = jsonObject.get("translation");
                    JSONArray jsonArray = JSONArray.fromObject(obj);
                    if(jsonArray!=null && jsonArray.size()>0){
                        return jsonArray.get(0)==null?"":jsonArray.get(0).toString();
                    }
                }
            }
        }catch (Exception e){
            log.info("翻译出错");
        }
        return "";
    }


    public static void main(String[] args) {
        System.out.println(getEnTranslateInfo("<a>learning</a>"));

    }

}
